From esx038@coventry.ac.uk Mon Jan  8 11:33 GMT 1996
Received: from coventry.ac.uk (root@mercury.coventry.ac.uk [193.61.107.16]) by mic2.hensa.ac.uk (8.6.12/8.6.12) with ESMTP id LAA10205 for <postmaster@mic2-atm.hensa.ac.uk>; Mon, 8 Jan 1996 11:33:27 GMT
Received: from leofric.coventry.ac.uk (esx038@leofric-fddi [193.61.107.33]) by coventry.ac.uk (8.6.12/8.6.11) with ESMTP id LAA02868; Mon, 8 Jan 1996 11:33:36 GMT
Received: (esx038@localhost) by leofric.coventry.ac.uk (8.6.12/8.6.9) id LAA09500; Mon, 8 Jan 1996 11:33:36 GMT
From: esx038@coventry.ac.uk
Date: Mon, 8 Jan 1996 11:33:36 GMT
Message-Id: <199601081133.LAA09500@leofric.coventry.ac.uk>
To: esx038@coventry.ac.uk, postmaster@mic2-atm.hensa.ac.uk
Content-Type: text
Content-Length: 18191
Status: OR

program asteroid;
{Research software written to produce files coded using the ASTEROID system.
ASTEROID is an acronym for
Algorithm Stating Technique Encouraging Reception Over Immense Distances.
Every time the asteroid system is used to encode an eight bit file into a
seven bit file that uses only standard printing characters a statement
concerning the encoding algorithm is place in the coded file. This is so
that any person receiving the file may write his or her own decoding program
for whatever system he or she is using.
}
{This program needs a parameter, namely an input filename.}
{It needs to be compiled to disc and run as a .exe file.}
{Started Monday 4th December 1995}
{Tuesday 5th December 1995}
{Progress so far, a working encoder of bytes for fixed file names,
saved as encoder.pas}
{Wednesday 6th December 1995}
{later the same day}
{Thursday 7th December 1995}
{Friday 8th December 1995}
{Monday 11th December 1995}
{Tuesday 12th December 1995}
{W. J. G. Overington at Coventry University, England}
{esx038@coventry.ac.uk}
var
inputByteFlow,outputByteFlow: file of byte;
inputTextFlow,outputTextFlow: text;
inputFile,outputFile: string[80];
inputByte,outputByte: byte;
numberByte: integer;
highNibble,lowNibble: integer;
highChar,lowChar: char;
sumOfBytesMod65536,totalNumberOfBytesMod65536: longint;
alongLineCount: integer;

inputIsAst,inputIsText,inputIsCode,outputIsText,outputIsCode,
                                                  outputIsKnown: Boolean;

parameterCount: integer;
parameterFilename,parameterFilenameSpine: string[80];
parameterFilenameSuffix: string[3];

inputBuffer,outputBuffer: string[80];

presentByte: integer;
presentByteString: string[2];
presentWordString: string[4];
actualSumOfBytesMod65536,actualTotalNumberOfBytesMod65536: longint;
purportedSumOfBytesMod65536,purportedTotalNumberOfBytesMod65536: longint;

firstNibble,secondNibble,thirdNibble,fourthNibble: longint;

begin {main program}

writeln(' The asteroid concept was invented and this particular asteroid');
writeln(' software written by W. J. G. Overington at Coventry University,');
writeln(' England during December 1995.                      Version 1.0');
writeln(' The asteroid concept is designed to simplify the distribution');
writeln(' of sets of files for distance education using newsgroups and');
writeln(' electronic mail and teletext systems using terrestrial');
writeln(' transmitters and direct broadcast satellites.');
writeln;
{check number of parameters, should be at least one}
parameterCount:=ParamCount;
if (parameterCount < 1) then
begin
writeln;
writeln(' You need an input filename as a parameter.');
writeln;
writeln(' In order to produce a file called describe.ast, prepare any');
writeln(' file called describe.zzz and then run');
writeln(' asteroid describe.zzz');
writeln(' whereupon your file describing this program will be produced.');
writeln;
writeln(' Please press Enter to finish ....');
readln;
Halt;
end;
parameterFilename:=ParamStr(1);

inputFile:=parameterFilename;

{get input filename and find the suffix}
parameterFilenameSpine:=Copy(parameterFilename,1,
                               Length(parameterFilename) - 4);
parameterFilenameSuffix:=Copy(parameterFilename,
                               Length(parameterFilename) - 2,3);

{Sort given file name as either .ast or otherwise,
if .ast decode, either as a text file after ---- or a file of byte
after ====; otherwise, if .htm, .txt or .doc, encode as .ast as a
---- file; otherwise encode as .ast as a ==== file}

{.ast             => inputIsText;
                                        ==== => outputIsCode
                                        ---- => outputIsText

.htm, .txt, .doc  => inputIsText, outputIsText

All others        => inputIsCode, outputIsText
}

if ((parameterFilenameSuffix = 'ast') or
    (parameterFilenameSuffix = 'AST')) then
begin
inputIsAst:=true;
inputIsText:=true;
inputIsCode:=false;

outputIsKnown:=false;
outputIsText:=false;   {may become true later}
outputIsCode:=false;   {may become true later}

outputFile:='';        {unknown as yet}
end
else if (
            (parameterFilenameSuffix = 'htm') or
            (parameterFilenameSuffix = 'txt') or
            (parameterFilenameSuffix = 'doc') or
            (parameterFilenameSuffix = 'HTM') or
            (parameterFilenameSuffix = 'TXT') or
            (parameterFilenameSuffix = 'DOC')
          ) then
begin
inputIsAst:=false;
inputIsText:=true;
inputIsCode:=false;

outputIsKnown:=true;
outputIsText:=true;
outputIsCode:=false;

outputFile:=Concat(parameterFilenameSpine,'.ast');
end
else {all other file suffices}
begin
inputIsAst:=false;
inputIsText:=false;
inputIsCode:=true;

outputIsKnown:=true;
outputIsText:=true;
outputIsCode:=false;

outputFile:=Concat(parameterFilenameSpine,'.ast');
end;


if (inputIsAst) then
begin
{open input file}
assign(inputTextFlow,inputFile);
reset(inputTextFlow);
{scan input file until
either ---- or ==== is
found.}
repeat
readln(inputTextFlow,inputBuffer);
until (eof(inputTextFlow) or (Pos('----',inputBuffer) <> 0)
                                 or (Pos('====',inputBuffer) <> 0));

if (eof(inputTextFlow)) then
begin
Halt;
end;

{Set outputIsKnown as true
and set either outputIsText
or outputIsCode to true as
respectively appropriate.
Set outputFile to the found name.}
outputIsKnown:=true;
outputFile:=Copy(inputBuffer,5,
                          Length(inputBuffer) - 4);
if (Pos('----',inputBuffer) <> 0) then
begin
outputIsText:=true;
end;

if (Pos('====',inputBuffer) <> 0) then
begin
outputIsCode:=true;
end;

if (outputIsKnown and outputIsText) then
{if it is ---- simply copy the rest of
the input file to a text file of the stated name.}
begin
assign(outputTextFlow,outputFile);
rewrite(outputTextFlow);

repeat
readln(inputTextFlow,inputBuffer);
outputBuffer:=inputBuffer;
writeln(outputTextFlow,outputBuffer);
until (eof(inputTextFlow));

close(inputTextFlow);
close(outputTextFlow);
end
else if (outputIsKnown and outputIsCode) then
{if it is ==== decode the rest of the input file to a file of
bytes of the stated name.
Report on sum and total number checks}
begin
assign(outputByteFlow,outputFile);
rewrite(outputByteFlow);

{START OF A LARGE SECTION OF BYTE DECODING}

repeat
readln(inputTextFlow,inputBuffer);

until (eof(inputTextFlow) or (Pos('yyyy',inputBuffer) <> 0));

actualSumOfBytesMod65536:=0;
actualTotalNumberOfBytesMod65536:=0;

repeat
begin
readln(inputTextFlow,inputBuffer);

if (Pos('zzzz',inputBuffer) = 0) then
begin

for presentByte:=1 to 32 do
begin
presentByteString:=Copy(inputBuffer,2 * presentByte - 1,2);

if (presentByteString <> 'xx') then
begin

highNibble:=ord(presentByteString[1]) - ord('a') + 1;
lowNibble:=ord(presentByteString[2]) - ord('a') + 1;
if (highNibble = 16) then
highNibble:=0;
if (lowNibble = 16) then
lowNibble:=0;

numberByte:=16*highNibble + lowNibble;

actualSumOfBytesMod65536:=actualSumOfBytesMod65536 + numberByte;
if (actualSumOfBytesMod65536 >= 65536) then
actualSumOfBytesMod65536:=actualSumOfBytesMod65536 - 65536;

actualTotalNumberOfBytesMod65536:=actualTotalNumberOfBytesMod65536 + 1;
if (actualTotalNumberOfBytesMod65536 >= 65536) then
actualTotalNumberOfBytesMod65536:=actualTotalNumberOfBytesMod65536 - 65536;

outputByte:=numberByte;

write(outputByteFlow,outputByte);

end; {if (presentByteString <> 'xx') then}

end; {for presentByte:=1 to 32 do}

end;
end; {if (Pos('zzzz',inputBuffer) = 0) then}
until (Pos('zzzz',inputBuffer) <> 0);


{}

repeat
readln(inputTextFlow,inputBuffer);
until (eof(inputTextFlow) or (Pos('ssss',inputBuffer) <> 0));

presentWordString:=Copy(inputBuffer,5,4);

firstNibble:=ord(presentWordString[1]) - ord('a') + 1;
secondNibble:=ord(presentWordString[2]) - ord('a') + 1;
thirdNibble:=ord(presentWordString[3]) - ord('a') + 1;
fourthNibble:=ord(presentWordString[4]) - ord('a') + 1;

if (firstNibble = 16) then
firstNibble:=0;
if (secondNibble = 16) then
secondNibble:=0;
if (thirdNibble = 16) then
thirdNibble:=0;
if (fourthNibble = 16) then
fourthNibble:=0;

purportedSumOfBytesMod65536:=16 * 16 * 16 * firstNibble +
                                16 * 16 * secondNibble +
                                   16 * thirdNibble +
                                        fourthNibble;

if (purportedSumOfBytesMod65536 = actualSumOfBytesMod65536) then
begin
writeln(' ssss check works');
end
else
begin
writeln(' ssss check does not work');
end;

writeln;
writeln(' The actual sum of bytes mod 65536 is    ',
                           actualSumOfBytesMod65536:5);
writeln;
writeln(' The purported sum of bytes mod 65536 is ',
                           purportedSumOfBytesMod65536:5);
writeln;

{}
                       
repeat
readln(inputTextFlow,inputBuffer);
until (eof(inputTextFlow) or (Pos('tttt',inputBuffer) <> 0));

presentWordString:=Copy(inputBuffer,5,4);

firstNibble:=ord(presentWordString[1]) - ord('a') + 1;
secondNibble:=ord(presentWordString[2]) - ord('a') + 1;
thirdNibble:=ord(presentWordString[3]) - ord('a') + 1;
fourthNibble:=ord(presentWordString[4]) - ord('a') + 1;

if (firstNibble = 16) then
firstNibble:=0;
if (secondNibble = 16) then
secondNibble:=0;
if (thirdNibble = 16) then
thirdNibble:=0;
if (fourthNibble = 16) then
fourthNibble:=0;

purportedTotalNumberOfBytesMod65536:=16 * 16 * 16 * firstNibble +
                                16 * 16 * secondNibble +
                                   16 * thirdNibble +
                                        fourthNibble;

if (purportedTotalNumberOfBytesMod65536 =
                           actualTotalNumberOfBytesMod65536) then
begin
writeln(' tttt check works');
end
else
begin
writeln(' tttt check does not work');
end;

writeln;
writeln(' The actual total number of bytes mod 65536 is    ',
                           actualTotalNumberOfBytesMod65536:5);
writeln;
writeln(' The purported total number of bytes mod 65536 is ',
                           purportedTotalNumberOfBytesMod65536:5);
writeln;

{END OF A LARGE SECTION OF BYTE DECODING}

close(inputTextFlow);
close(outputByteFlow);
end; {if (outputIsKnown and <choice>)}

end {if inputIsAst}
else
begin {therefore not inputIsAst}

{.htm, .txt, .doc}
if (inputIsText and outputIsText) then
begin
assign(inputTextFlow,inputFile);
reset(inputTextFlow);
assign(outputTextFlow,outputFile);
rewrite(outputTextFlow);
writeln(outputTextFlow,'----',inputFile);

repeat
readln(inputTextFlow,inputBuffer);
outputBuffer:=inputBuffer;
writeln(outputTextFlow,outputBuffer);
until (eof(inputTextFlow));

close(inputTextFlow);
close(outputTextFlow);
end
{all other file suffices}
else if (inputIsCode and outputIsText) then
begin

{START OF A LARGE SECTION ENCODING A FILE OTHER THAN .htm, .txt OR .doc}

assign(inputByteFlow,inputFile);
reset(inputByteFlow);

assign(outputTextFlow,outputFile);
rewrite(outputTextFlow);

writeln(outputTextFlow,'This file is coded using the ASTEROID system.');
writeln(outputTextFlow,'ASTEROID is an acronym for');
write  (outputTextFlow,'Algorithm Stating Technique Encouraging Reception');
writeln(outputTextFlow,' Over Immense Distances.');
write  (outputTextFlow,'Every time the asteroid system is used to encode');
writeln(outputTextFlow,' an eight bit file into a');
write  (outputTextFlow,'seven bit file that uses only standard printing');
writeln(outputTextFlow,' characters this');
write  (outputTextFlow,'statement concerning the encoding algorithm is');
writeln(outputTextFlow,' place in the coded file.');
write  (outputTextFlow,'This is so that any person receiving the file');
writeln(outputTextFlow,' may write his or her');
write  (outputTextFlow,'own decoding program for whatever system he or');
writeln(outputTextFlow,' she is using.');
write  (outputTextFlow,'The asteroid system was originally devised to');
writeln(outputTextFlow,' enable image files used');
write  (outputTextFlow,'in groups of hypertext files to be distributed');
writeln(outputTextFlow,' efficiently in the');
write  (outputTextFlow,'Usenet newsgroup alt.education.distance, so that');
writeln(outputTextFlow,' those files could');
write  (outputTextFlow,'be used to produce a locally available hypertext');
writeln(outputTextFlow,' educational package.');
writeln(outputTextFlow,'');
write  (outputTextFlow,'In the asteroid system, four = characters followed');
writeln(outputTextFlow,' by a file name');
write  (outputTextFlow,'indicate the name of the file into which the');
writeln(outputTextFlow,' decoded bytes go.');
writeln(outputTextFlow,'Four y characters signal the start of the bytes.');
writeln(outputTextFlow,'Each line carries 32 bytes, encoded as 64 letters.');
writeln(outputTextFlow,'Four z characters signal the end of the bytes.');
write  (outputTextFlow,'Four s characters and then four characters give a');
writeln(outputTextFlow,' sum count modulo 65536');
write  (outputTextFlow,'of the values of all the bytes in the');
writeln(outputTextFlow,' eight bit file.');
write  (outputTextFlow,'Four t characters and then four characters give a');
writeln(outputTextFlow,' count modulo 65536');
writeln(outputTextFlow,'of the number of bytes in the eight bit file.');
write  (outputTextFlow,'All bytes from the eight bit file and the');
writeln(outputTextFlow,' two bytes for each of the');
write  (outputTextFlow,'special facilities four s and four t are coded as');
writeln(outputTextFlow,' two lowercase letters');
writeln(outputTextFlow,'from just over the first half of the alphabet.');
write  (outputTextFlow,'A character 69, interpreted in text files as an E');
writeln(outputTextFlow,' character, would');
write  (outputTextFlow,'be 0100 0101, and would be coded as de because');
writeln(outputTextFlow,' the coding is');
write  (outputTextFlow,'0001 -> a, 0010 -> b .... 1110 -> n, 1111 -> o');
writeln(outputTextFlow,' together with');
write  (outputTextFlow,'0000 -> p so as to use only letters.');
writeln(outputTextFlow,'');

writeln(outputTextFlow,'The x character may be used as padding at the end.');
writeln(outputTextFlow);

write  (outputTextFlow,'A full encoding and decoding program asteroid.exe');
writeln(outputTextFlow,' should take');
write  (outputTextFlow,'one filename as a parameter. If that filename is');
writeln(outputTextFlow,' a .ast file,');
write  (outputTextFlow,'decoding should take place, either as above, or');
writeln(outputTextFlow,' where four -');
write  (outputTextFlow,'characters preceed the filename, as a text file');
writeln(outputTextFlow,' consisting of');
writeln(outputTextFlow,'all subsequent lines of the .ast file.');
writeln(outputTextFlow);
write  (outputTextFlow,'Where a .htm, .txt or .doc file is used, a .ast');
writeln(outputTextFlow,' file of the text');
write  (outputTextFlow,'preceeded by a line carying four - characters');
writeln(outputTextFlow,' and the name of the');
write  (outputTextFlow,'original file should be produced. All other');
writeln(outputTextFlow,' files such as .gif');
writeln(outputTextFlow,'should produce an encoded file as above.');
writeln(outputTextFlow);
write  (outputTextFlow,'This enables sets of files, some of which are');
writeln(outputTextFlow,' text and some of');
write  (outputTextFlow,'which are images, to be encoded as a set of .ast');
writeln(outputTextFlow,' files.');
writeln(outputTextFlow);

writeln(outputTextFlow,'====',inputFile);
writeln(outputTextFlow,'yyyy');

alongLineCount:=0;

sumOfBytesMod65536:=0;
totalNumberOfBytesMod65536:=0;

while (not(eof(inputByteFlow))) do
begin
read(inputByteFlow,inputByte);
numberByte:=inputByte;

sumOfBytesMod65536:=sumOfBytesMod65536 + numberByte;
if (sumOfBytesMod65536 >= 65536) then
sumOfBytesMod65536:=sumOfBytesMod65536 - 65536;

totalNumberOfBytesMod65536:=totalNumberOfBytesMod65536 + 1;
if (totalNumberOfBytesMod65536 >= 65536) then
totalNumberOfBytesMod65536:=totalNumberOfBytesMod65536 - 65536;

highNibble:=numberByte div 16;
lowNibble:=numberByte mod 16;

if (highNibble = 0) then
highChar:='p'
else
highChar:=chr(ord('a') + highNibble - 1);

if (lowNibble = 0) then
lowChar:='p'
else
lowChar:=chr(ord('a') + lowNibble - 1);

alongLineCount:=alongLineCount + 1;
if (alongLineCount >= 32) then
begin
writeln(outputTextFlow,highChar,lowChar);
alongLineCount:=0;
end
else
begin
write(outputTextFlow,highChar,lowChar);
end;


end; {while (not(eof(inputByteFlow) do}
close(inputByteFlow);

{}

if (alongLineCount <> 0) then
begin
while (alongLineCount <> 0) do
begin
alongLineCount:=alongLineCount + 1;

if (alongLineCount >= 32) then
begin
writeln(outputTextFlow,'xx');
alongLineCount:=0;
end
else
begin
write(outputTextFlow,'xx');
end;

end; {while (alongLineCount <> 0) do}

end; {if (alongLineCount <> 0) then}

writeln(outputTextFlow,'zzzz');

write(outputTextFlow,'ssss');

numberByte:=sumOfBytesMod65536 div 256;

highNibble:=numberByte div 16;
lowNibble:=numberByte mod 16;

if (highNibble = 0) then
highChar:='p'
else
highChar:=chr(ord('a') + highNibble - 1);

if (lowNibble = 0) then
lowChar:='p'
else
lowChar:=chr(ord('a') + lowNibble - 1);

write(outputTextFlow,highChar,lowChar);

{}

numberByte:=sumOfBytesMod65536 mod 256;

highNibble:=numberByte div 16;
lowNibble:=numberByte mod 16;

if (highNibble = 0) then
highChar:='p'
else
highChar:=chr(ord('a') + highNibble - 1);

if (lowNibble = 0) then
lowChar:='p'
else
lowChar:=chr(ord('a') + lowNibble - 1);

writeln(outputTextFlow,highChar,lowChar);

{}

write(outputTextFlow,'tttt');

numberByte:=totalNumberOfBytesMod65536 div 256;

highNibble:=numberByte div 16;
lowNibble:=numberByte mod 16;

if (highNibble = 0) then
highChar:='p'
else
highChar:=chr(ord('a') + highNibble - 1);

if (lowNibble = 0) then
lowChar:='p'
else
lowChar:=chr(ord('a') + lowNibble - 1);

write(outputTextFlow,highChar,lowChar);

{}

numberByte:=totalNumberOfBytesMod65536 mod 256;

highNibble:=numberByte div 16;
lowNibble:=numberByte mod 16;

if (highNibble = 0) then
highChar:='p'
else
highChar:=chr(ord('a') + highNibble - 1);

if (lowNibble = 0) then
lowChar:='p'
else
lowChar:=chr(ord('a') + lowNibble - 1);

writeln(outputTextFlow,highChar,lowChar);

close(outputTextFlow);

{END OF A LARGE SECTION ENCODING A FILE OTHER THAN .htm, .txt OR .doc}

end; {the total if structure for file suffices}

end; {therefore not inputIsAst}

end.

